﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using moxa;

namespace moxa.v460
{
    public class DigitalInput
    {
        public DigitalInput() { }

        public static int Get(int index)
        {

            mxdevice dev = new mxdevice("\\\\.\\DIODev");

            if (dev.Open())
            {
                int nBytesReturn = 0;
                uint nDIOBack = 0;

                mxdevice._DIO dio = new mxdevice._DIO();
                int nSize = Marshal.SizeOf(dio);
                dio.port = index;
                
                IntPtr lpDIO = Marshal.AllocHGlobal(nSize);
                Marshal.StructureToPtr(dio, lpDIO, false);

                //if (!dev.DeviceIoControl(mxdevice.IOCTL_GET_DIN, lpDIO, nSize, lpDIO, nSize, ref nBytesReturn, IntPtr.Zero))
                //{
                //    Marshal.FreeHGlobal(lpDIO);
                //    return -1;
                //}

                if (!dev.DeviceIoControl(mxdevice.IOCTL_GET_DIN, lpDIO, nSize, ref nDIOBack, sizeof(uint), ref nBytesReturn, IntPtr.Zero))
                {
                    Marshal.FreeHGlobal(lpDIO);
                    return -1;
                }

//                mxdevice._DIO dioback = (mxdevice._DIO)Marshal.PtrToStructure(lpDIO, typeof(mxdevice._DIO));
                //Marshal.Release(lpDIO);
                dev.Close();
                Marshal.FreeHGlobal(lpDIO);

                dev = null;

                return (int)nDIOBack;
//                return dioback.data;
            }
            else
            {
                dev = null;
                return -1;
            }

            return 0;
        }

        public static byte GetAll()
        {
            mxdevice dev = new mxdevice("\\\\.\\DIODev");

            if (dev.Open())
            {
                byte bIn = 0, bOut = 0;

                if (!dev.IoControl(mxdevice.IOCTL_GET_DIN_ALL, ref bIn, ref bOut))
                {
                    dev = null;
                    return 0;
                }

                dev.Close();

                dev = null;
                return bOut;
            }
            else
            {
                dev = null;
                return 0;
            }
        }
    }

    public class DigitalOutput
    {
        public DigitalOutput() { }

        public static int Get(int index)
        {
            mxdevice dev = new mxdevice("\\\\.\\DIODev");

            if (index < 0 || index > 7)
            {
                dev = null;
                return -1;
            }

            if (dev.Open())
            {
                int nBytesReturn = 0;
                uint nDIOBack=0;
                mxdevice._DIO dio = new mxdevice._DIO();
                int nSize = Marshal.SizeOf(dio);
                dio.port = index;

                IntPtr lpDIO = Marshal.AllocHGlobal(nSize);
                Marshal.StructureToPtr(dio, lpDIO, false);

                if (!dev.DeviceIoControl(mxdevice.IOCTL_GET_DOUT, lpDIO, nSize, ref nDIOBack, sizeof(uint), ref nBytesReturn, IntPtr.Zero))
                {
                    Marshal.FreeHGlobal(lpDIO);
                    return -1;
                }

                //mxdevice._DIO dioback = (mxdevice._DIO)Marshal.PtrToStructure(lpDIO, typeof(mxdevice._DIO));
                //Marshal.Release(lpDIO);
                dev.Close();
                Marshal.FreeHGlobal(lpDIO);

                dev = null;
                //return dioback.data;
                return (int)nDIOBack;
            }
            else
            {
                dev = null;
                return -1;
            }
        }

        public static bool Set(int index, int value)
        {
            mxdevice dev = new mxdevice("\\\\.\\DIODev");

            if (index < 0 || index > 7)
            {
                dev = null;
                return false;
            }
            if (value != 0 && value != 1)
            {
                dev = null;
                return false;
            }

            if (dev.Open())
            {
                int nBytesReturn = 0;
                mxdevice._DIO dio = new mxdevice._DIO();
                int nSize = Marshal.SizeOf(dio);
                dio.port = index;
                dio.data = value;

                IntPtr lpDIO = Marshal.AllocHGlobal(nSize);
                Marshal.StructureToPtr(dio, lpDIO, false);

                if (!dev.DeviceIoControl(mxdevice.IOCTL_SET_DOUT, lpDIO, nSize, IntPtr.Zero, 0, ref nBytesReturn, IntPtr.Zero))
                {
                    Marshal.FreeHGlobal(lpDIO);
                    return false;
                }
                dev.Close();
                Marshal.FreeHGlobal(lpDIO);

               
                dev = null;
                return true;
            }
            else
            {
                
                dev = null;
                return false;
            }
        }

    }
}
