﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace moxa.v460
{
    public class SerialInterface
    {
        public SerialInterface()
        { }
        ~SerialInterface()
        { }

        public enum SerialMode : byte
        {
            UNKNOWN = 0xFF,
            RS232_MODE = 0x0,
            RS485_2WIRE_MODE = 0x1,
            RS422_RS485_4WIRE_MODE = 0x2             
        }


        public static SerialMode getUartMode(int nPort)
        {
            String valueName = "COM" + nPort;
            Object value;
            Microsoft.Win32.RegistryKey key;
          
            {
                key = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\\MOXA\\COM");
                if (key == null) //If the key doesn't exist.
                {
                    Console.WriteLine("The registry key doesn't exist");
                }
                value = key.GetValue(valueName);
                //Console.WriteLine("Value:{0} for {1} is successfully retrieved.", value, valueName);

            }
           
            return (SerialMode)(int)value;
        }

        public static bool setUartMode(int nPort, SerialMode nMode)
        {
            String valueName = "COM" + nPort;
            Object value = (int)nMode;
            Microsoft.Win32.RegistryKey key;
           
            key = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\\MOXA\\COM", true);
            if (key == null) //If the key doesn't exist.
            {
                Console.WriteLine("The registry key doesn't exist");
            }
            //Set the value.
            key.SetValue(valueName, value);

            //Console.WriteLine("Value:{0} for {1} is successfully written.", value, valueName);
            return true;
        }
    }
}
