/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "..\release\devices.h"


#define MAX_DIN_NUMBER	8
#define MAX_DOUT_NUMBER 8

/*
	index[n]: 0  ; BIT 0
			  1  ; BIT 1
	          2  ; BIT 2
	          3  ; BIT 3
			  ....
	data[n]: 0  ; Digital LOW
	         1  ; Digital HIGH
	         
*/

int _tmain(int argc, _TCHAR* argv[])
{

	HANDLE	hDIO;
	int port_no;
	int data;
	int	intDout,intDin;
	int	nDout=0;
	int port=0,mode=0;
	int n=0;

	WCHAR sin;
	printf("UART Mode Test Program\n");
    printf("\t (0) Exit Program\n");
    printf("\t (1) Display DIN\n");
    printf("\t (2) Display DOUT\n");
	printf("\t (3) Set DOUT value\n");
	printf("\t (4) Display both DIN and DOUT\n");

	sin=getwchar();
	n=_wtoi(&sin);
	
	do
    {
        switch (n)
        {
            // if char == '1', display the digital input
            case 1:
				//Open dio
				hDIO=mxdio_open();

				for(int i=0;i<MAX_DIN_NUMBER;i++)
				{
					//Get digital input
					port_no=i;
					intDin=mxdio_get_din(hDIO,port_no);
					printf("Din%d = %d\n",port_no,intDin);
				}

				//Close DIO
                mxdio_close(hDIO);
                break;

			// if char == '2', display the digital output
			case 2:
				//Open dio
				hDIO=mxdio_open();

				for(int i=0;i<MAX_DOUT_NUMBER;i++)
				{
					//Get digital input
					port_no=i;
					intDin=mxdio_get_dout(hDIO,port_no);
					printf("Dout%d = %d\n",port_no,intDin);
				}

				//Close DIO
                mxdio_close(hDIO);
				break;
            // if char == '3', Set the digital output
            case 3:
             
				//Get Port Number
				printf("Input the Port Number (0 ~ %d) = \n",MAX_DOUT_NUMBER-1);
				scanf("%d",&port_no);
			
				//Get Value
                printf("Input the value (0 or 1) = ");
				scanf("%d",&data);
		
				//Open DIO
				hDIO=mxdio_open();
				//Set DOUT
				nDout=mxdio_set_dout(hDIO,port_no, data);
				if(!nDout)
				{
					printf("Set digital output fail!\n");
				}
				else
				{
					printf("Set digital output success!\n");
				}

				//Close DIO
				mxdio_close(hDIO);
                break;

			case 4:
				// if char == '4', Get both digital input and digital output
				//Open dio
				hDIO=mxdio_open();

				for(int i=0;i<MAX_DOUT_NUMBER;i++)
				{
					//Get digital input
					port_no=i;
					intDin=mxdio_get_din(hDIO,port_no);
					intDout=mxdio_get_dout(hDIO,port_no);
					printf("Din%d = %d, Dout%d = %d\n",port_no,intDin,port_no,intDout);
				}

				//Close DIO
                mxdio_close(hDIO);
				break;

				break;
        }
		getwchar();
        sin = getwchar();
        n = _wtoi(&sin);
    } while (n != 0);

	return 0;
}

