/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

/*
	index[n]: 3  ; Port 3
			  4  ; Port 4
	          
			 ....
	mode[n]: 0  ; RS232
	         1  ; RS485-2W
			 2  ; RS422
			 3  ; RS485-4W
	         
*/

#include "stdafx.h"
#include <windows.h>
#include "..\release\devices.h"
char mode_array[][20]={"RS232", "RS485-2W", "RS422","RS485-4W"};

int _tmain(int argc, _TCHAR* argv[])
{
	int port=0,mode=0;
	int n=0;

	WCHAR sin;
	WCHAR wcs_port[3],wcs_mode[3];
	printf("UART Mode Test Program\n");
    printf("\t (0) Exit Program\n");
    printf("\t (1) Display UART Mode\n");
    printf("\t (2) Set UART Mode\n");

	sin=getwchar();
	n=_wtoi(&sin);
	
	
	do
    {
        switch (n)
        {
            // if char == '1', display the UART Mode
            case 1:
				printf("Input the Port Number (3 or 4) = \n");
				wscanf(L"%s",wcs_port);
				port=_wtoi(wcs_port);
				mode=uart_getmode(port);
				if(mode==(-1))
				{
					printf("Invalid value!!\n");
					break;
				}

				printf("COM%d=%s\n",port,mode_array[mode]);
				
                break;
            // if char == '2', Set the UART Mode
            case 2:
             
				//Get Port Number
				printf("Input the Port Number (3 or 4) = \n");
				wscanf(L"%s",wcs_port);
				port=_wtoi(wcs_port);
			
				//Get Mode Value
                printf("Input the Mode value (0 ~ 3) = ");
				wscanf(L"%s",wcs_mode);
				mode=_wtoi(wcs_mode);
		
				//Set UART Mode
				if(uart_setmode(port,mode)==-1)
				{
					printf("Invalid value!!\n");
					printf("Set UART Mode Fail!!\n");
					break;
				}                
				else
				{
					printf("COM%d=%s\n",port,mode_array[mode]);
				}
                break;
        }
		getwchar();
        sin = getwchar();
        n = _wtoi(&sin);
    } while (n != 0);

	return 0;
}

